﻿using System;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            #region 이벤트를 설정한다.

            this.statusButton.Click += statucButton_Click;
            this.exitButton.Click  += exitButton_Click;

            #endregion
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region 방화벽 상태 버튼 클릭시 처리하기 - statucButton_Click(sender, e)

        /// <summary>
        /// 방화벽 상태 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void statucButton_Click(object sender, EventArgs e)
        {
            Type FWManagerType = Type.GetTypeFromProgID("HNetCfg.FwMgr");

            dynamic FWManager = Activator.CreateInstance(FWManagerType);

            if(FWManager.LocalPolicy.CurrentProfile.FirewallEnabled)
            {
                MessageBox.Show(this, "방화벽이 작동중입니다.");
            }
            else
            {
                MessageBox.Show(this, "방화벽이 작동하고 있지 않습니다.");
            }
        }

        #endregion
        #region 종료 버튼 클릭시 처리하기 - exitButton_Click(sender, e)

        /// <summary>
        /// 종료 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void exitButton_Click(object sender, EventArgs e)
        {
            Close();
        }

        #endregion
    }
}